// $ANTLR 2.7.7 (20060906): "SMIParser.g" -> "SMILexer.java"$

package org.jsmiparser.phase.file.antlr;

import org.jsmiparser.util.token.*;
import org.jsmiparser.smi.*;
import org.jsmiparser.phase.file.*;
import org.jsmiparser.util.location.Location;

import antlr.*;
import java.lang.* ;
import java.math.*;
import java.util.*;

public interface SMITokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int ABSENT_KW = 4;
	int ABSTRACT_SYNTAX_KW = 5;
	int ALL_KW = 6;
	int ANY_KW = 7;
	int ARGUMENT_KW = 8;
	int APPLICATION_KW = 9;
	int AUTOMATIC_KW = 10;
	int BASED_NUM_KW = 11;
	int BEGIN_KW = 12;
	int BIT_KW = 13;
	int BMP_STRING_KW = 14;
	int BOOLEAN_KW = 15;
	int BY_KW = 16;
	int CHARACTER_KW = 17;
	int CHOICE_KW = 18;
	int CLASS_KW = 19;
	int COMPONENTS_KW = 20;
	int COMPONENT_KW = 21;
	int CONSTRAINED_KW = 22;
	int DEFAULT_KW = 23;
	int DEFINED_KW = 24;
	int DEFINITIONS_KW = 25;
	int EMBEDDED_KW = 26;
	int END_KW = 27;
	int ENUMERATED_KW = 28;
	int ERROR_KW = 29;
	int ERRORS_KW = 30;
	int EXCEPT_KW = 31;
	int EXPLICIT_KW = 32;
	int EXPORTS_KW = 33;
	int EXTENSIBILITY_KW = 34;
	int EXTERNAL_KW = 35;
	int FALSE_KW = 36;
	int FROM_KW = 37;
	int GENERALIZED_TIME_KW = 38;
	int GENERAL_STR_KW = 39;
	int GRAPHIC_STR_KW = 40;
	int IA5_STRING_KW = 41;
	int IDENTIFIER_KW = 42;
	int IMPLICIT_KW = 43;
	int IMPLIED_KW = 44;
	int IMPORTS_KW = 45;
	int INCLUDES_KW = 46;
	int INSTANCE_KW = 47;
	int INTEGER_KW = 48;
	int INTERSECTION_KW = 49;
	int ISO646STRING_KW = 50;
	int LINKED_KW = 51;
	int MAX_KW = 52;
	int MINUS_INFINITY_KW = 53;
	int MIN_KW = 54;
	int NULL_KW = 55;
	int NUMERIC_STR_KW = 56;
	int OBJECT_DESCRIPTOR_KW = 57;
	int OBJECT_KW = 58;
	int OCTET_KW = 59;
	int OPERATION_KW = 60;
	int OF_KW = 61;
	int OID_KW = 62;
	int OPTIONAL_KW = 63;
	int PARAMETER_KW = 64;
	int PDV_KW = 65;
	int PLUS_INFINITY_KW = 66;
	int PRESENT_KW = 67;
	int PRINTABLE_STR_KW = 68;
	int PRIVATE_KW = 69;
	int REAL_KW = 70;
	int RELATIVE_KW = 71;
	int RESULT_KW = 72;
	int SEQUENCE_KW = 73;
	int SET_KW = 74;
	int SIZE_KW = 75;
	int STRING_KW = 76;
	int TAGS_KW = 77;
	int TELETEX_STR_KW = 78;
	int TRUE_KW = 79;
	int TYPE_IDENTIFIER_KW = 80;
	int UNION_KW = 81;
	int UNIQUE_KW = 82;
	int UNIVERSAL_KW = 83;
	int UNIVERSAL_STR_KW = 84;
	int UTC_TIME_KW = 85;
	int UTF8STRING_KW = 86;
	int VIDEOTEX_STR_KW = 87;
	int VISIBLE_STR_KW = 88;
	int WITH_KW = 89;
	int ASSIGN_OP = 90;
	int BAR = 91;
	int COLON = 92;
	int COMMA = 93;
	int COMMENT = 94;
	int DOT = 95;
	int DOTDOT = 96;
	int ELLIPSIS = 97;
	int EXCLAMATION = 98;
	int INTERSECTION = 99;
	int LESS = 100;
	int L_BRACE = 101;
	int L_BRACKET = 102;
	int L_PAREN = 103;
	int MINUS = 104;
	int PLUS = 105;
	int R_BRACE = 106;
	int R_BRACKET = 107;
	int R_PAREN = 108;
	int SEMI = 109;
	int SINGLE_QUOTE = 110;
	int CHARB = 111;
	int CHARH = 112;
	int WS = 113;
	int SMIC_DIRECTIVE = 114;
	int INCLUDE = 115;
	int SL_COMMENT = 116;
	int NUMBER = 117;
	int UPPER = 118;
	int LOWER = 119;
	int BDIG = 120;
	int HDIG = 121;
	int B_OR_H_STRING = 122;
	int B_STRING = 123;
	int H_STRING = 124;
	int C_STRING = 125;
	// "OBJECT-TYPE" = 126
	// "MODULE-IDENTITY" = 127
	// "OBJECT-IDENTITY" = 128
	// "NOTIFICATION-TYPE" = 129
	// "TEXTUAL-CONVENTION" = 130
	// "OBJECT-GROUP" = 131
	// "NOTIFICATION-GROUP" = 132
	// "MODULE-COMPLIANCE" = 133
	// "AGENT-CAPABILITIES" = 134
	// "TRAP-TYPE" = 135
	int LITERAL_MACRO = 136;
	int LITERAL_BITS = 137;
	int LITERAL_SYNTAX = 138;
	int LITERAL_UNITS = 139;
	int LITERAL_ACCESS = 140;
	// "MAX-ACCESS" = 141
	int LITERAL_STATUS = 142;
	int LITERAL_DESCRIPTION = 143;
	int LITERAL_REFERENCE = 144;
	int LITERAL_INDEX = 145;
	int LITERAL_AUGMENTS = 146;
	int LITERAL_DEFVAL = 147;
	// "LAST-UPDATED" = 148
	int LITERAL_ORGANIZATION = 149;
	// "CONTACT-INFO" = 150
	int LITERAL_REVISION = 151;
	int LITERAL_OBJECTS = 152;
	// "DISPLAY-HINT" = 153
	int LITERAL_NOTIFICATIONS = 154;
	int LITERAL_MODULE = 155;
	// "MANDATORY-GROUPS" = 156
	int LITERAL_GROUP = 157;
	// "WRITE-SYNTAX" = 158
	// "MIN-ACCESS" = 159
	// "PRODUCT-RELEASE" = 160
	int LITERAL_SUPPORTS = 161;
	int LITERAL_VARIATION = 162;
	// "CREATION-REQUIRES" = 163
	int LITERAL_ENTERPRISE = 164;
	int LITERAL_VARIABLES = 165;
}
